config/routes.rb
UKPortal::Application.routes.draw do
  resources :roles

  devise_for :users

  root :to => "portal#index"

end

app/models/assignment.rb
class Assignment < ActiveRecord::Base
  belongs_to :user
  belongs_to :role
end

app/models/role.rb
class Role < ActiveRecord::Base
  has_many :assignments
  has_many :users, :through => :assignments
end

app/models/user.rb
class User < ActiveRecord::Base
  # Include default devise modules. Others available are:
  # :token_authenticatable, :confirmable, :lockable and :timeoutable
  devise :database_authenticatable, :registerable,
         :recoverable, :rememberable, :trackable, :validatable,
         :token_authenticatable, :lockable,:timeoutable, :invitable

  # Setup accessible (or protected) attributes for your model
  attr_accessible :email, :password, :password_confirmation, :remember_me

  has_many :assignments
  has_many :roles, :through => :assignments

  def role_symbols
    roles.map do |role|
      role.name.underscore.to_sym
    end
  end
end

app/controllers/application_controller.rb
class ApplicationController < ActionController::Base
  protect_from_forgery
  include SslRequirement

end

app/controllers/portal_controller.rb
class PortalController < ApplicationController
  before_filter :authenticate_user!, :except => [:index]


  def index
  end

end

app/controllers/roles_controller.rb
class RolesController < ApplicationController
  # GET /roles
  # GET /roles.xml
  def index
    @roles = Role.all

    respond_to do |format|
      format.html # index.html.erb
      format.xml  { render :xml => @roles }
    end
  end

  # GET /roles/1
  # GET /roles/1.xml
  def show
    @role = Role.find(params[:id])

    respond_to do |format|
      format.html # show.html.erb
      format.xml  { render :xml => @role }
    end
  end

  # GET /roles/new
  # GET /roles/new.xml
  def new
    @role = Role.new

    respond_to do |format|
      format.html # new.html.erb
      format.xml  { render :xml => @role }
    end
  end

  # GET /roles/1/edit
  def edit
    @role = Role.find(params[:id])
  end

  # POST /roles
  # POST /roles.xml
  def create
    @role = Role.new(params[:role])

    respond_to do |format|
      if @role.save
        format.html { redirect_to(@role, :notice => 'Role was successfully created.') }
        format.xml  { render :xml => @role, :status => :created, :location => @role }
      else
        format.html { render :action => "new" }
        format.xml  { render :xml => @role.errors, :status => :unprocessable_entity }
      end
    end
  end

  # PUT /roles/1
  # PUT /roles/1.xml
  def update
    @role = Role.find(params[:id])

    respond_to do |format|
      if @role.update_attributes(params[:role])
        format.html { redirect_to(@role, :notice => 'Role was successfully updated.') }
        format.xml  { head :ok }
      else
        format.html { render :action => "edit" }
        format.xml  { render :xml => @role.errors, :status => :unprocessable_entity }
      end
    end
  end

  # DELETE /roles/1
  # DELETE /roles/1.xml
  def destroy
    @role = Role.find(params[:id])
    @role.destroy

    respond_to do |format|
      format.html { redirect_to(roles_url) }
      format.xml  { head :ok }
    end
  end
end

app/helpers/application_helper.rb
module ApplicationHelper
end

app/helpers/portal_helper.rb
module PortalHelper
end

app/helpers/roles_helper.rb
module RolesHelper
end

app/views/layouts/application.html.erb
<!DOCTYPE html>
<html>
<head>
  <title>UKPortal</title>
  <%= stylesheet_link_tag 'blueprint/screen.css', :media => 'screen,projection' %>
  <%= stylesheet_link_tag 'blueprint/print.css', :media => 'print' %>

  <%= stylesheet_link_tag 'dropdown/dropdown.css', :media => 'screen,projection' %>
  <%= stylesheet_link_tag 'dropdown/dropdown.vertical.css', :media => 'screen,projection' %>
  <%= stylesheet_link_tag 'dropdown/themes/default.ultimate.css', :media => 'screen,projection' %>

  <!--[if lt IE 8]>
	<%= stylesheet_link_tag 'blueprint/ie.css', :media => 'screen,projection' %>
  <![endif]-->
  <%= javascript_include_tag 'jquery','rails', :cache => 'jquery'%>
  <%= javascript_include_tag 'application' %>
  <%= csrf_meta_tag %>
</head>
<body>
  <div class="container">
  	<div class="span-20">
  		<h1>Basic Portal System</h1>
  		<h3>Application Portal to Style to your desires</h3>
  	</div>
    <div class="span-4 last">
    </div>
  	<div class="span-4">
  		<%= render :partial => "portal/menu" %>
  	</div>
  	<div class="span-20 last">
          <% flash.each do |key, value| %>
          <%= content_tag :div, value, :id => key, :class => key %>
          <% end %>
          <%= yield %>
  	</div>
  	<div class="span-24">
          <h4>Copyright &copy; <%= Time.now.year %> My Company</h4>
  	</div>
  </div>
</body>
</html>

app/views/portal/_menu.html.erb
<ul id="nav" class="dropdown dropdown-vertical">
	<li><a href="/">Home</a></li>
  <% if current_user %>
    <li><%= link_to "Sign Out", destroy_user_session_path %></li>
    <li><span class="dir">My Account</span>
      <ul>
        <li><%= link_to "Do Something", "#" %></li>
      </ul>
    </li>
  <% else %>
    <li><%= link_to "Sign In", new_user_session_path %></li>
    <li><%= link_to "Create Account", new_user_registration_path %></li>
  <% end %>	
</ul>

app/views/portal/index.html.erb
<h1>Portal#index</h1>
<p>Find me in app/views/portal/index.html.erb</p>

app/views/roles/_form.html.erb
<%= form_for(@role) do |f| %>
  <% if @role.errors.any? %>
    <div id="error_explanation">
      <h2><%= pluralize(@role.errors.count, "error") %> prohibited this role from being saved:</h2>

      <ul>
      <% @role.errors.full_messages.each do |msg| %>
        <li><%= msg %></li>
      <% end %>
      </ul>
    </div>
  <% end %>

  <div class="field">
    <%= f.label :name %><br />
    <%= f.text_field :name %>
  </div>
  <div class="actions">
    <%= f.submit %>
  </div>
<% end %>

app/views/roles/edit.html.erb
<h1>Editing role</h1>

<%= render 'form' %>

<%= link_to 'Show', @role %> |
<%= link_to 'Back', roles_path %>

app/views/roles/index.html.erb
<h1>Listing roles</h1>

<table>
  <tr>
    <th>Name</th>
    <th></th>
    <th></th>
    <th></th>
  </tr>

<% @roles.each do |role| %>
  <tr>
    <td><%= role.name %></td>
    <td><%= link_to 'Show', role %></td>
    <td><%= link_to 'Edit', edit_role_path(role) %></td>
    <td><%= link_to 'Destroy', role, :confirm => 'Are you sure?', :method => :delete %></td>
  </tr>
<% end %>
</table>

<br />

<%= link_to 'New Role', new_role_path %>

app/views/roles/new.html.erb
<h1>New role</h1>

<%= render 'form' %>

<%= link_to 'Back', roles_path %>

app/views/roles/show.html.erb
<p id="notice"><%= notice %></p>

<p>
  <b>Name:</b>
  <%= @role.name %>
</p>


<%= link_to 'Edit', edit_role_path(@role) %> |
<%= link_to 'Back', roles_path %>